part of '../mqtt.dart';

class MqttMessageConnack extends MqttMessage {
  MqttConnectReturnCode returnCode = MqttConnectReturnCode.noneSpecified;

  /// Initializes a new instance of the MqttConnectAckMessage class.
  MqttMessageConnack.fromByteBuffer(
      MqttFixedHead header, MqttBuffer messageStream) {
    fixedHead = header;
    readFrom(messageStream);
  }
  @override
  void readFrom(MqttBuffer messageStream) {
    super.readFrom(messageStream);
    final _ = messageStream.readBits();
    final ret = messageStream.readBits();
    returnCode = MqttConnectReturnCode.values[ret];
  }

  @override
  String toString() =>
      fixedHead.toString() +
      'return:' +
      fixedHead.yellow(returnCode.toString());
}
